git-svn: fix some potential bugs with --follow-parent
[git/dscho.git] / git-tag.sh
blob4a0a7b660780b7c377ce80ac49dc99cea3e8137d
1 #!/bin/sh
2 # Copyright (c) 2005 Linus Torvalds
4 USAGE='-l [<pattern>] | [-a | -s | -u <key-id>] [-f | -d | -v] [-m <msg>] <tagname> [<head>]'
5 SUBDIRECTORY_OK='Yes'
6 . git-sh-setup
8 message_given=
9 annotate=
10 signed=
11 force=
12 message=
13 username=
14 list=
15 verify=
16 while case "$#" in 0) break ;; esac
18     case "$1" in
19     -a)
20         annotate=1
21         ;;
22     -s)
23         annotate=1
24         signed=1
25         ;;
26     -f)
27         force=1
28         ;;
29     -l)
30         case "$#" in
31         1)
32                 set x . ;;
33         esac
34         shift
35         git rev-parse --symbolic --tags | sort | grep "$@"
36         exit $?
37         ;;
38     -m)
39         annotate=1
40         shift
41         message="$1"
42         if test "$#" = "0"; then
43             die "error: option -m needs an argument"
44         else
45             message_given=1
46         fi
47         ;;
48     -F)
49         annotate=1
50         shift
51         if test "$#" = "0"; then
52             die "error: option -F needs an argument"
53         else
54             message="$(cat "$1")"
55             message_given=1
56         fi
57         ;;
58     -u)
59         annotate=1
60         signed=1
61         shift
62         username="$1"
63         ;;
64     -d)
65         shift
66         had_error=0
67         for tag
68         do
69                 cur=$(git-show-ref --verify --hash -- "refs/tags/$tag") || {
70                         echo >&2 "Seriously, what tag are you talking about?"
71                         had_error=1
72                         continue
73                 }
74                 git-update-ref -m 'tag: delete' -d "refs/tags/$tag" "$cur" || {
75                         had_error=1
76                         continue
77                 }
78                 echo "Deleted tag $tag."
79         done
80         exit $had_error
81         ;;
82     -v)
83         shift
84         tag_name="$1"
85         tag=$(git-show-ref --verify --hash -- "refs/tags/$tag_name") ||
86                 die "Seriously, what tag are you talking about?"
87         git-verify-tag -v "$tag"
88         exit $?
89         ;;
90     -*)
91         usage
92         ;;
93     *)
94         break
95         ;;
96     esac
97     shift
98 done
100 name="$1"
101 [ "$name" ] || usage
102 prev=0000000000000000000000000000000000000000
103 if git-show-ref --verify --quiet -- "refs/tags/$name"
104 then
105     test -n "$force" || die "tag '$name' already exists"
106     prev=`git rev-parse "refs/tags/$name"`
108 shift
109 git-check-ref-format "tags/$name" ||
110         die "we do not like '$name' as a tag name."
112 object=$(git-rev-parse --verify --default HEAD "$@") || exit 1
113 type=$(git-cat-file -t $object) || exit 1
114 tagger=$(git-var GIT_COMMITTER_IDENT) || exit 1
116 test -n "$username" ||
117         username=$(git-repo-config user.signingkey) ||
118         username=$(expr "z$tagger" : 'z\(.*>\)')
120 trap 'rm -f "$GIT_DIR"/TAG_TMP* "$GIT_DIR"/TAG_FINALMSG "$GIT_DIR"/TAG_EDITMSG' 0
122 if [ "$annotate" ]; then
123     if [ -z "$message_given" ]; then
124         ( echo "#"
125           echo "# Write a tag message"
126           echo "#" ) > "$GIT_DIR"/TAG_EDITMSG
127         ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR"/TAG_EDITMSG || exit
128     else
129         echo "$message" >"$GIT_DIR"/TAG_EDITMSG
130     fi
132     grep -v '^#' <"$GIT_DIR"/TAG_EDITMSG |
133     git-stripspace >"$GIT_DIR"/TAG_FINALMSG
135     [ -s "$GIT_DIR"/TAG_FINALMSG -o -n "$message_given" ] || {
136         echo >&2 "No tag message?"
137         exit 1
138     }
140     ( printf 'object %s\ntype %s\ntag %s\ntagger %s\n\n' \
141         "$object" "$type" "$name" "$tagger";
142       cat "$GIT_DIR"/TAG_FINALMSG ) >"$GIT_DIR"/TAG_TMP
143     rm -f "$GIT_DIR"/TAG_TMP.asc "$GIT_DIR"/TAG_FINALMSG
144     if [ "$signed" ]; then
145         gpg -bsa -u "$username" "$GIT_DIR"/TAG_TMP &&
146         cat "$GIT_DIR"/TAG_TMP.asc >>"$GIT_DIR"/TAG_TMP ||
147         die "failed to sign the tag with GPG."
148     fi
149     object=$(git-mktag < "$GIT_DIR"/TAG_TMP)
152 git update-ref "refs/tags/$name" "$object" "$prev"